SystemOrganization addCategory: #Numeros!

Object subclass: #Numero
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Numeros'!

Numero subclass: #Entero
	instanceVariableNames: 'numero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Numeros'!

!Entero class methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 03:35'!
numero: unNumero

	^(self new)numero: unNumero.! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 04:24'!
= otroNumero

	^ otroNumero numero = numero.! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 06:18'!
dividido: otroNumero

	^ otroNumero dividimeAEsteEntero: self.! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:41'!
dividimeAEstaFraccion: unaFraccion.

	^(unaFraccion numerador por: (Entero numero: 1)) dividido:(unaFraccion divisor por: self). ! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:27'!
dividimeAEsteEntero: unEntero

	|mcd|
	
	mcd:= self maximoComunDivisorCon: unEntero.
	
	((self dividirPorMcd: mcd) esUno) ifTrue: [^ Entero numero: (unEntero numero / self numero)]
	
	 ifFalse: [^Fraccion numerador: ( unEntero dividirPorMcd:  mcd) divisor: ( self dividirPorMcd:  mcd)]

	! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:25'!
dividirPorMcd: suMcd

	^Entero numero: (self numero / suMcd numero).! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 03:34'!
esCero

	^ numero = 0.! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 03:39'!
esUno

	^ numero = 1.! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 04:24'!
hash

	^ numero.! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:31'!
mas: otroNumero

	^otroNumero sumaloPorEsteEntero: self.! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:08'!
maximoComunDivisorCon: otroEntero

	| masChico masGrande|
	
	(otroEntero numero >= self numero) ifTrue: [masGrande:= otroEntero. masChico:= self.] ifFalse:[masChico:= otroEntero. masGrande:= self.]. 

	^(masChico esCero) ifTrue: [^masGrande] ifFalse: [ masChico maximoComunDivisorCon: (masGrande restoDeDividirPor: masChico)] ! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:41'!
multiplicaloPorEstaFraccion: unaFraccion.

	^ (self por: unaFraccion numerador)  dividido: unaFraccion divisor.! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:56'!
multiplicaloPorEsteEntero: unEntero.

	^Entero numero: self numero * unEntero numero.! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 03:42'!
numero
	
	^numero.! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 03:36'!
numero: unNumero

	numero := unNumero.! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:55'!
por: otroNumero

	^ otroNumero multiplicaloPorEsteEntero: self.! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 06:55'!
restoDeDividirPor: otroEntero
	
	^ Entero numero: (numero \\ otroEntero numero)! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:48'!
sumaloPorEsteEntero: otroEntero

	^Entero numero: numero + otroEntero numero.! !

!Entero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:40'!
sumameloPorEstaFraccion: otraFraccion

		^((self por: otraFraccion divisor) mas: (otraFraccion numerador por: (Entero numero: 1))) dividido:((Entero numero: 1) por: otraFraccion divisor).! !

Numero subclass: #Fraccion
	instanceVariableNames: 'numerador divisor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Numeros'!

!Fraccion class methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 04:33'!
numerador: unEntero divisor: otroEntero

	^(self new)numerador: unEntero divisor: otroEntero.! !

!Fraccion methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 04:47'!
=otraFraccion

	^(numerador por: otraFraccion divisor) = (divisor por: otraFraccion numerador).! !

!Fraccion methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 06:26'!
dividido: otraFraccion

	^otraFraccion dividimeAEstaFraccion: self.! !

!Fraccion methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:47'!
dividimeAEstaFraccion: otraFraccion.

	^ (otraFraccion numerador por: divisor) dividido:(otraFraccion divisor por: numerador). ! !

!Fraccion methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 06:32'!
dividimeAEsteEntero: unEntero

	^Fraccion numerador: (unEntero por: divisor) divisor: numerador.

	! !

!Fraccion methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 04:40'!
divisor

	^divisor.! !

!Fraccion methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 04:37'!
hash

	^numerador numero / divisor numero. ! !

!Fraccion methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:46'!
mas: otroNumero

	^otroNumero sumameloPorEstaFraccion: self.! !

!Fraccion methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:39'!
multiplicaloPorEstaFraccion: unaFraccion

	^(numerador por: unaFraccion numerador) dividido:(divisor por: unaFraccion divisor). ! !

!Fraccion methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:40'!
multiplicaloPorEsteEntero: unEntero.

^ (unEntero por: numerador) dividido: divisor. ! !

!Fraccion methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 04:40'!
numerador

	^numerador.! !

!Fraccion methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:31'!
numerador: unEntero divisor: otroEntero

	numerador:= unEntero.
	divisor:= otroEntero. 
	! !

!Fraccion methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 06:00'!
por: unNumero

	^unNumero multiplicaloPorEstaFraccion: self.! !

!Fraccion methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:40'!
sumaloPorEsteEntero: unEntero

		^((numerador por: (Entero numero: 1)) mas: (unEntero por: divisor)) dividido:(divisor por: (Entero numero: 1)). ! !

!Fraccion methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:39'!
sumameloPorEstaFraccion: otraFraccion

			^((numerador por: otraFraccion divisor) mas: (otraFraccion numerador por: divisor)) dividido: (divisor por: otraFraccion divisor). ! !

!Numero methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 03:40'!
mas: otroNumero

	^self subclassResponsibility.! !

TestCase subclass: #NumeroTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Numeros'!

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 03:36'!
cero

	^Entero numero: 0.! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 04:42'!
cinco

	^Entero numero: 5.! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:34'!
cincoMedios

	^self cinco dividido: self dos.! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 04:25'!
cuatro

	^Entero numero: 4.! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 04:42'!
diez

	^Entero numero: 10.! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 03:40'!
dos

	^Entero numero: 2.! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:34'!
dosCuartos

	^self dos dividido: self cuatro.! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:35'!
dosQuintos

	^self dos dividido:  self cinco.! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:10'!
dosVeinticincoavos

	^Fraccion numerador: self dos divisor:  self veinticino.! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:51'!
seis

	^Entero numero: 6.! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:50'!
seisQuintos

	^Fraccion numerador: self seis divisor:  self cinco.! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 04:41'!
siete

	^Entero numero: 7.! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 04:41'!
sieteDecimos

	^Fraccion numerador: self siete divisor: self diez.! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:52'!
test01EsCeroDevuelveCeroSoloParaElCero

	self assert: (self cero esCero).
	self deny: (self uno esCero).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:52'!
test02EsUnoDevuelveTrueSoloParaElUno

	self assert: (self uno esUno).
	self deny: (self cero esUno).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:53'!
test03SumaDeEnteros

	self assert: self cinco equals: (self uno mas: self cuatro).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:53'!
test04MultiplicacionDeEnteros

	self assert: self cuatro equals: (self dos por: self dos).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:53'!
test05DivisionDeEnteros

	self assert: self uno equals: (self dos dividido: self dos).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:53'!
test06SumaDeFracciones

	self assert: self sieteDecimos equals: (self unQuinto mas: self unMedio).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:53'!
test07MultiplicacionDeFracciones

	self assert: self dosVeinticincoavos  equals: (self unQuinto por: self dosQuintos).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:54'!
test08DivisionDeFracciones

	self assert: self cincoMedios   equals: (self unMedio dividido: self unQuinto).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:54'!
test09SumaDeEnterosYFraccion

	self assert: self seisQuintos equals: (self uno mas: self unQuinto).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:52'!
test10SumaDeFraccionYEntero

	self assert: self seisQuintos equals: (self unQuinto mas: self uno).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 06:09'!
test11MultiplicacionDeEnteroPorFraccion

	self assert: self dosQuintos  equals: (self dos por: self unQuinto ).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 06:09'!
test12MultiplicacionDeFraccionPorEntero

	self assert: self dosQuintos  equals: (self unQuinto  por: self dos ).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 06:32'!
test13DivisionDeEnteroPorFraccion

	self assert: self cincoMedios  equals: (self uno  dividido: self dosQuintos  ).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 06:33'!
test14DivisionDeFraccionPorEntero

	self assert: self dosVeinticincoavos equals: (self dosQuintos dividido: self cinco).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:08'!
test14MaximoComunDivisor

	self assert: self dos equals: (self cuatro maximoComunDivisorCon: self dos).
	self assert: self dos equals: (self diez  maximoComunDivisorCon: self dos).
	self assert: self dos equals: (self diez  maximoComunDivisorCon: self cuatro).
	self assert: self uno equals: (self diez  maximoComunDivisorCon: self siete).
	self assert: self diez equals: (self diez  maximoComunDivisorCon: self diez).
	self assert: self dos equals: (self cuatro  maximoComunDivisorCon: self diez).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:32'!
test15UnaFraccionPuedeSerIgualAUnEntero

	self assert: self dos equals: (self cuatro dividido: self dos).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:34'!
test16LasFraccionesAparentesSonIguales

	self assert: self unMedio equals: (self dosCuartos).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:43'!
test17LaSumaDeFraccionesPuedeDarEntero

	self assert: self uno equals: (self unMedio mas: self unMedio).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:43'!
test18LaMultiplicacionDeFraccionesPuedeDarEntero

	self assert: self dos equals: (self cuatro por: self unMedio).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:44'!
test19LaDivisionDeEnterosPuedeDarFraccion

	self assert: self unMedio equals: (self dos dividido: self cuatro).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:45'!
test20LaDivisionDFraccionesPuedeDarEntero

	self assert: self uno equals: (self unMedio dividido: self unMedio).! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 07:36'!
unMedio

	^ self uno dividido:  self dos.! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 04:42'!
unQuinto

	^Fraccion numerador: self uno divisor:  self cinco.! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 03:37'!
uno

	^Entero numero: 1.! !

!NumeroTest methodsFor: 'as yet unclassified' stamp: 'PabloFromer 7/18/2012 05:10'!
veinticino 

	^Entero numero: 25.! !
